#include <zephyr/kernel.h>
#include <pm_config.h>
#include <zephyr/drivers/flash.h>


#define PARTITION_DEVICE DEVICE_DT_GET(DT_NODELABEL(flash0))
#define PARTITION_OFFSET PM_NVS_STORAGE_ADDRESS
#define PARTITION_SIZE   PM_NVS_STORAGE_SIZE

void main(void)
{
    const struct device *flash_dev = PARTITION_DEVICE;

    printk("Partition Manager Sample\n");

    if (!device_is_ready(flash_dev)) {
        printk("Flash device is not ready\n");
        return;
    }

    printk("Partition offset: 0x%x\n", PARTITION_OFFSET);
    printk("Partition size: 0x%x\n", PARTITION_SIZE);

    // Example: Reading from the partition
    // uint8_t buffer[16];
    // int ret = flash_read(flash_dev, PARTITION_OFFSET, buffer, sizeof(buffer));
    // if (ret != 0) {
    //     printk("Flash read failed\n");
    // } else {
    //     printk("Data read: ");
    //     for (int i = 0; i < sizeof(buffer); i++) {
    //         printk("0x%02x ", buffer[i]);
    //     }
    //     printk("\n");
    // }
}